unit hiHD44780;

interface

uses Kol,Share,WINDOWS,Debug;

type
  THIHD44780 = class(TDebug)
   private
    LPT_CR:byte;             //     LPT ( )
	LCD_CR:byte;             //    
   
   public

    _data_DataChar:THI_Event;
    _data_DataReg:THI_Event;
    
	_event_onLCD_Data:THI_Event;
	_event_onLCD_Control:THI_Event;
    _event_onLCD_Control_LPT:THI_Event;
   

      procedure _work_doIniLCD(var _Data:TData; Index:word); 
      procedure _work_doSendChar(var _Data:TData; Index:word);
      procedure _work_doSendReg(var _Data:TData; Index:word);
      procedure SendChar(X:byte); //   
      procedure SendReg(X:byte);  //     (.)        
      procedure SleepMks(mks:integer);
  
  
  
  
  
  end;

implementation


////////////////////////////////////////////////////////////////////////////////
///   
////////////////////////////////////////////////////////////////////////////////
procedure THIHD44780._work_doSendChar; //                
var i:integer;
begin                                              
    i := ReadInteger(_Data,_data_DataChar);// 
	SendChar(i);
end;              
////////////////////////////////////////////////////////////////////////////////
///     
////////////////////////////////////////////////////////////////////////////////
procedure THIHD44780._work_doSendReg; //                
var  i:integer;
begin                                              
    i := ReadInteger(_Data,_data_DataReg);//
	SendReg(i);//        
end;              
////////////////////////////////////////////////////////////////////////////////
///  
////////////////////////////////////////////////////////////////////////////////
procedure THIHD44780._work_doIniLCD;                 //     Port+0
var i:integer;
begin   //     0
/////////////MessageBox(0,' ','!!!',MB_OK+MB_ICONERROR);
LPT_CR := 11 ;//    
LCD_CR := 0;
SleepMks(4100);
 
SendReg($30);//     
SleepMks(4100);
SendReg($30);//     
SleepMks(100);
SendReg($30);//     
SleepMks(100);
SendReg($38);//     
SleepMks(100);
SendReg($0C);//      - ,   .
SleepMks(100);  
SendReg($01);//  
SleepMks(100);
SendReg($06);//       
SleepMks(100);
end;                                                 
//================  =========================================================
procedure THIHD44780.SendReg; //                   

begin                                              
    LPT_CR := LPT_CR and not (1 shl 2);//  RS  3 ( )
	LCD_CR := LCD_CR and not (1 shl 2);//  RS  3
	_hi_OnEvent(_event_onLCD_Control_LPT,LPT_CR);//
	_hi_OnEvent(_event_onLCD_Control,LCD_CR);// 
    LPT_CR := LPT_CR and not (1 shl 0);//   0 ()
	LCD_CR := LCD_CR or (1 shl 0);//
	_hi_OnEvent(_event_onLCD_Control_LPT,LPT_CR);//
	_hi_OnEvent(_event_onLCD_Control,LCD_CR);// 
	_hi_OnEvent(_event_onLCD_Data,X);
    SleepMks(50);
	LPT_CR := LPT_CR or (1 shl 0);//   0 ()
	LCD_CR := LCD_CR and not (1 shl 0);//
	_hi_OnEvent(_event_onLCD_Control_LPT,LPT_CR);//
	_hi_OnEvent(_event_onLCD_Control,LCD_CR);// 
	SleepMks(50);
	
end;
//================  =======================================================                                                 
procedure THIHD44780.SendChar; //                   

begin                                              
    LPT_CR := LPT_CR or (1 shl 2);//  RS  3
	LCD_CR := LCD_CR or (1 shl 2);// 
	_hi_OnEvent(_event_onLCD_Control_LPT,LPT_CR);//
	_hi_OnEvent(_event_onLCD_Control,LCD_CR);// 
	LPT_CR := LPT_CR and not (1shl 0);//   0 ()
	LCD_CR := LCD_CR or (1 shl 0);// 
	_hi_OnEvent(_event_onLCD_Control_LPT,LPT_CR);//
	_hi_OnEvent(_event_onLCD_Control,LCD_CR);// 
	_hi_OnEvent(_event_onLCD_Data,X);
    SleepMks(50);
    LPT_CR := LPT_CR or (1 shl 0);//   0 ()
	LCD_CR := LCD_CR and not (1 shl 0);//  RS  3
	_hi_OnEvent(_event_onLCD_Control_LPT,LPT_CR);//
	_hi_OnEvent(_event_onLCD_Control,LCD_CR);// 
    SleepMks(50);
end;
//=================  =======================================================                                                 
procedure THIHD44780.SleepMks;
var sp,ep,cnt:int64;
begin
   QueryPerformanceCounter(sp);
   QueryPerformanceFrequency(cnt);
   cnt := cnt div 1000000;
   repeat
     QueryPerformanceCounter(ep);
   until (ep - sp)div cnt > mks;
  
end;
// I := I or (1 shl N); //  
// I := I and not (1 shl N); //  
// I := I xor (1 shl N); //  
// if (i and (1 shl N)) <> 0 then... //   

end.
